#!/usr/bin/perl -w 
use strict;
#use diagnostics;

#(This license is from zlib of Jean-loup Gailly and Mark Adler)
#
# Copyright (C) 2002 Frederick Dean <software@fdd.com>
#
#  This software is provided 'as-is', without any express or implied
#  warranty.  In no event will the authors be held liable for any damages
#  arising from the use of this software.
#
#  Permission is granted to anyone to use this software for any purpose,
#  including commercial applications, and to alter it and redistribute it
#  freely, subject to the following restrictions:
#
#  1. The origin of this software must not be misrepresented; you must not
#     claim that you wrote the original software. If you use this software
#     in a product, an acknowledgment in the product documentation would be
#     appreciated but is not required.
#  2. Altered source versions must be plainly marked as such, and must not be
#     misrepresented as being the original software.
#  3. This notice may not be removed or altered from any source distribution.
#
# Contributor(s):    Frederick Dean <software@fdd.com>

BEGIN { push(@INC,"/var/www/html/dcvs"); }   # library include path

require config;
use db;
#use cvsdb;

if(! defined $ARGV[0] || $ARGV[0] ne "--dataloss") {
   print STDERR "\n".
                "      Your DCVS database will loose all revisions!\n".
                "      Only run this script if you want to loose data!\n".
                "      Use the --dataloss flag if you are sure.\n".
                "      The database was not altered.\n".
                "\n";
   exit -1;
}

db::SendSQL("DELETE FROM dirent");  # delete all directories and files
db::SendSQL("DELETE FROM descendent");  # delete all descendents
db::SendSQL("DELETE FROM revision");  # delete all revisions
db::SendSQL("DELETE FROM btime");  # delete all branches


db::SendSQL("REPLACE dirent SET file_id = 5000, fname = 'revtest', type = 'dir', parent = 0");
db::SendSQL("REPLACE dirent SET file_id = 6000, fname = 'file1', type = 'file', parent = 5000"); 
db::SendSQL("REPLACE dirent SET file_id = 6001, fname = 'file2', type = 'file', parent = 5000");  # no revisions
db::SendSQL("REPLACE dirent SET file_id = 6002, fname = 'file3', type = 'file', parent = 5000");  # no main trunk revisions
db::SendSQL("REPLACE revision SET rev_id=7000, file_id=6000, revision='1.1', comment_id=1000, ".
            "state='Exp', timestamp=1000");  # no errors
db::SendSQL("REPLACE revision SET rev_id=7001, file_id=6000, revision='11', comment_id=1000, ".
            "state='Exp', timestamp=1000");  # no period in revision name
db::SendSQL("REPLACE revision SET rev_id=7002, file_id=6000, revision='1.1x', comment_id=1000, ".
            "state='Exp', timestamp=1000");  # illegal char in revision name
db::SendSQL("REPLACE revision SET rev_id=7003, file_id=5999, revision='1.2', comment_id=1000, ".
            "state='Exp', timestamp=1000");  # nonexistent file
db::SendSQL("REPLACE revision SET rev_id=7004, file_id=6002, revision='1.2.3.4', comment_id=1000, ".
            "state='Exp', timestamp=1000");  # no main trunk revisions 



