#!/usr/bin/perl -w
use strict;

BEGIN { push @INC, "/var/www/html/dcvs" };

use cvsdb;
use Digest::MD5 qw(md5_base64);

#
#  This is some white box texting.
#  We retrieve every revision and check their md5 and length.
#

$|++;  # disable buffering

db::SendSQL("SELECT dirent.file_id,fname,revision,md5,length,rev_id FROM revision, dirent ".
            "WHERE dirent.file_id = revision.file_id AND md5 != '' ".
            "ORDER BY file_id,-rev_id");
my @files = db::FetchListOfLists();
print($#files . " revisions\n");
my $starttime = time;
foreach my $file (@files) {
   my($file_id,$fname,$revision,$md5,$length,$rev_id) = @$file;

   #print("$file_id $md5 $rev_id $revision $length $fname\n");
   my $text = cvsdb::GetText($file_id,$revision);
   if(md5_base64($text) ne $md5) {
      if($length != length($text)) {
         print("########### MD5 and length ($length != ".length($text).") are wrong $revision $fname\n");
      } else {
         print("########### MD5 is wrong $revision $fname\n");
      }
   } elsif($length != length($text)) {
      print("########### length is wrong $revision $fname ($length != ".length($text).")\n");
   } else {
      #print("okay $revision $fname\n");
   }
}
print(time - $starttime, " seconds\n");


